/***************************************************************************
                          kdlgmain.h  -  description
                             -------------------
    begin                : Sat Jun 17 2000
    copyright            : (C) 2000 by sva
    email                : svanpo@cybercable.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KDLGMAIN_H
#define KDLGMAIN_H

//Generated area. DO NOT EDIT!!!(begin)
#include <qwidget.h>
#include <qgroupbox.h>
#include <qlabel.h>
//Generated area. DO NOT EDIT!!!(end)

#include <ktmainwindow.h>
#include <klineedit.h>
#include <kmenubar.h>
#include <kwizard.h>
#include <qtimer.h>
typedef struct _sgNetworkInfos
{
	// Receive
	int		rBytes;
	int		rPackets;
	int		rErrs;
	int		rDrop;
	int		rFifo;
	int		rFrame;
	int		rCompressed;
	int		rMulticast;
	// Transmit
	int		tBytes;
	int		tPackets;
	int		tErrs;
	int		tDrop;
	int		tFifo;
	int		tColls;
	int		tCarrier;
	int		tCompressed;
}sgNetworkInfos;

typedef struct _sgValue2
{
	int		upload;
	int		download;
}sgValue2;

typedef struct _sgValue
{
	double		upload;
	double		download;
}sgValue;


/**
  *@author sva
  */

//class KDlgMain : public KDialog
class KDlgMain : public KTMainWindow
{
   	Q_OBJECT

	public:
		KDlgMain(QWidget *parent=0, const char *name=0);
		~KDlgMain();

	  	/** Lit les informations sur un priphrique rseau dfini */
  		sgNetworkInfos readNetDeviceInfo(char *dev);
  		void initMenu(void);

	protected:
		void 		initDialog();
  		void 		readConfFile(void);
  		void 		initControls(void);
  		void 		setTitle(void);

	  	QTimer 		*mTimer;
		sgValue		mStart;
		sgValue		mLast;
		sgValue		mAnalyserSession;
		sgValue		mToday;
		sgValue		mMonth;
		KMenuBar    *mMenubar;

		KLineEdit	*mUEditLinuxSession;
		KLineEdit	*mDEditLinuxSession;
 		KLineEdit	*mDEditAnalyserSession;
		KLineEdit	*mUEditAnalyserSession;
		KLineEdit	*mDEditToday;
		KLineEdit	*mUEditToday;
		KLineEdit	*mDEditCurrentMonth;
		KLineEdit	*mUEditCurrentMonth;
	  	QString 	mNetworkAdapter;
  		int 		mRefreshRate;

	//Generated area. DO NOT EDIT!!!(begin)
	QGroupBox *mGroupUpload;
	QLabel *mUStaticAnalyserSession;
	QLabel *mUStaticToday;
	QLabel *mUStaticCurrentMonth;
	QLabel *mUStaticLinuxSession;
	QGroupBox *mGroupDownload;
	QLabel *mDStaticLinuxSession;
	QLabel *mDStaticAnalyserSession;
	QLabel *mDStaticCurrentMonth;
	QLabel *mDStaticToday;
	//Generated area. DO NOT EDIT!!!(end)

	private:

	protected slots: // Protected slots
		void timerTimeout(void);
  		void quit(void);
  		void stat_upload_download(void);
  		void stat_ip_address(void);
  		void configuration(void);
		void reset_analyser_session(void);
  		void about(void);
};

#endif
