/***************************************************************************
                          klistbox.cpp  -  description
                             -------------------
    begin                : Thu Jul 27 2000
    copyright            : (C) 2000 by sva
    email                : svanpo@cybercable.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/***************************************************************************
                          klistbox.cpp  -  description
                             -------------------
    begin                : Sun Apr 23 2000
    copyright            : (C) 2000 by sva
    email                : svanpo@cybercable.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdlib.h>
#include <ctype.h>
#include "klistbox.h"

KListBox::KListBox(QWidget *parent, const char *name ) : QListView(parent,name)
{
	setSeparator('|');					// KListBox
	setFrameStyle(Panel|Sunken);		// QFrame
	setAlternatedColor1(QColor(white));
	setAlternatedColor2(QColor(white));
	setAllColumnsShowFocus(true);
	setFocusPolicy(QWidget::StrongFocus);
}

KListBox::~KListBox()
{
}

void KListBox::setSeparator(char iSeparator)
{
	cSeparator = iSeparator;
}

void KListBox::setColumns(char *iColumns)
{
	char	*lChar;
	char	*lColumnName = new char[strlen(iColumns)+1];
	char	*lCharColumnName;

	*lColumnName = 0;

	lChar = iColumns;
	lCharColumnName = lColumnName;
	while (*lChar!=0)
	{
		if (*lChar!=cSeparator)
		{
			*lCharColumnName = *lChar;
			lCharColumnName++;
		}
		else
		{
			*lCharColumnName = 0;
			lCharColumnName = lColumnName;
			addColumn(lColumnName);
		}
		lChar++;
	}
	*lCharColumnName = 0;
	addColumn(lColumnName);

	delete(lColumnName);
}

void KListBox::setSizes(char *iSizes)
{
	char	*lChar;
	char	*lSize = new char[strlen(iSizes)+1];
	char	*lCharSize;
	int		lColumnNum=0;

	*lSize = 0;

	lChar = iSizes;
	lCharSize = lSize;
	while (*lChar!=0)
	{
		if (*lChar!=cSeparator)
		{
			*lCharSize = *lChar;
			lCharSize++;
		}
		else
		{
			*lCharSize = 0;
			lCharSize = lSize;
			setColumnWidth(lColumnNum, atoi(lSize)-1);
			lColumnNum++;
		}
		lChar++;
	}
	*lCharSize = 0;
	setColumnWidth(lColumnNum, atoi(lSize));

	delete(lSize);
}

void KListBox::setAlignments(char *iAlignments)
{
	char	*lChar;
	char	*lAlignment = new char[strlen(iAlignments)+1];
	char	*lCharAlignment;
	int		lColumnNum=0;

	*lAlignment = 0;

	lChar = iAlignments;
	lCharAlignment = lAlignment;
	while (*lChar!=0)
	{
		if (*lChar!=cSeparator)
		{
			*lCharAlignment = *lChar;
			lCharAlignment++;
		}
		else
		{
			*lCharAlignment = 0;
			lCharAlignment = lAlignment;
			switch(*lAlignment)
			{
				case 'L':	// Left
				case 'l':	{
								setColumnAlignment(lColumnNum, AlignLeft);
								break;
							}
				case 'C':	// Center
				case 'c':	{
								setColumnAlignment(lColumnNum, AlignCenter);
								break;
							}
				case 'R':	// Right
				case 'r':	{
								setColumnAlignment(lColumnNum, AlignRight);
								break;
							}
			}
			lColumnNum++;
		}
		lChar++;
	}
	*lCharAlignment = 0;

	switch(*lAlignment)
	{
		case 'L':	// Left
		case 'l':	{
						setColumnAlignment(lColumnNum, AlignLeft);
						break;
					}
		case 'C':	// Center
		case 'c':	{
						setColumnAlignment(lColumnNum, AlignCenter);
						break;
					}
		case 'R':	// Right
		case 'r':	{
						setColumnAlignment(lColumnNum, AlignRight);
						break;
					}
	}

	delete(lAlignment);
}

KListBoxItem *KListBox::insert(char *iLine)
{
	char			*lChar;
	char			*lColumn = new char[strlen(iLine)+1];
	char			*lCharColumn;
	int				lColumnNum=0;
	KListBoxItem    *lItem;

	*lColumn = 0;

	lItem = new KListBoxItem(this);
	lChar = iLine;
	lCharColumn = lColumn;
	while (*lChar!=0)
	{
		if (*lChar!=cSeparator)
		{
			*lCharColumn = *lChar;
			lCharColumn++;
		}
		else
		{
			*lCharColumn = 0;
			lCharColumn = lColumn;
			lItem->setText(lColumnNum, lColumn);
			lColumnNum++;
		}
		lChar++;
	}
	*lCharColumn = 0;
	lItem->setText(lColumnNum, lColumn);

	delete(lColumn);
	return(lItem);
}

void KListBox::setAlternatedColor1(QColor iColor)
{
	cAlternatedColor1 = iColor;
}

void KListBox::setAlternatedColor2(QColor iColor)
{
	cAlternatedColor2 = iColor;
}

QColor KListBox::getAlternatedColor1(void)
{
	return(cAlternatedColor1);
}

QColor KListBox::getAlternatedColor2(void)
{
	return(cAlternatedColor2);
}

