/***************************************************************************
                          ktabconfgeneral.cpp  -  description
                             -------------------
    begin                : Sun Jun 25 2000
    copyright            : (C) 2000 by sva
    email                : svanpo@cybercable.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <kapp.h>
#include <stdio.h>
#include <qstrlist.h>
#include "ktabconfgeneral.h"

KTabConfGeneral::KTabConfGeneral(QWidget *parent, const char *name) : QWidget(parent,name)
{
	KConfig		*lConfig;
	QString		lNetAdapter;
	int			lRefreshRate;
	int			lIndexLine;

	setFixedSize(50,50);

	// QComboBox
	initDialog();
	loadAdapters();

	lConfig = kapp->getConfig();

	// -----------------------------------------------------------------------------------
	// Read the general section
	// -----------------------------------------------------------------------------------
	lConfig->setGroup("General");
	// Load the network adapter in the combo box
	lNetAdapter = lConfig->readEntry("Network adapter", "lo");
	for (lIndexLine=0; lIndexLine<mComboBoxNetworkAdapter->count()-1; lIndexLine++)
	{
		if (strcmp((const char *)lNetAdapter, mComboBoxNetworkAdapter->text(lIndexLine))==0)
		{
			mComboBoxNetworkAdapter->setCurrentItem(lIndexLine);
			break;
		}
	}
    // Set the refresh rate
	lRefreshRate = lConfig->readNumEntry("Refresh rate", 5);
	mSliderRefreshRate->setValue(lRefreshRate);
	slotValueChanged(lRefreshRate);

	// Set displayed informations
	mCheckBoxLinuxSession->setChecked(lConfig->readBoolEntry("Linux session", true));
	mCheckBoxUDAnalyserSession->setChecked(lConfig->readBoolEntry("U/D Analyser session", true));
	mCheckBoxToday->setChecked(lConfig->readBoolEntry("Today", true));
	mCheckBoxCurrentMonth->setChecked(lConfig->readBoolEntry("Current month", true));

	connect(mSliderRefreshRate, SIGNAL(valueChanged(int)), SLOT(slotValueChanged(int)));
}

KTabConfGeneral::~KTabConfGeneral()
{
}

void KTabConfGeneral::loadAdapters(void)
{
	FILE			*lFile;
	char			*lIndexChar;
	char			lLine[1025];
	char			*lDev;
	QStrIList       lDevList;

	lFile = fopen("/proc/net/dev", "rt");
	if (lFile!=NULL)
	{
		// Read 2 dummy lines
		fgets(lLine, sizeof(lLine)-1, lFile);
		fgets(lLine, sizeof(lLine)-1, lFile);
		while (!feof(lFile))
		{
			fgets(lLine, sizeof(lLine)-1, lFile);

			if (!feof(lFile))
			{
				lIndexChar=lLine;
				// Recherche le dbut des donnes
				while ((*lIndexChar==' ') && (*lIndexChar!=0)) lIndexChar++;
				lDev = lIndexChar;
				while ((*lIndexChar!=':') && (*lIndexChar!=0)) lIndexChar++;
				*lIndexChar=0;

				lDevList.inSort(lDev);
			}
		}
		fclose(lFile);
	}
	else fprintf(stderr, i18n("Can't open /proc/dev/net directory.\n"));

	// Insert network adapter
    lDev = lDevList.first();
	while ((lDev!=NULL) && (lDev[0]!=0))
	{
		mComboBoxNetworkAdapter->insertItem(lDev);
	    lDev = lDevList.next();
	}
}

void KTabConfGeneral::slotValueChanged(int value)
{
	char	lRefreshRate[50];

	sprintf(lRefreshRate, "%d s.", value);
	mStaticRefreshRateValue->setText(lRefreshRate);
}
